unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, FileCtrl, ExtCtrls, Grids, Outline, DirOutln, Buttons,
  WAInt;
Const SFL=10000;
Const CFG='MP3.CFG';
type
  Tform1 = class(TForm)
    ListBox1: TListBox;
    Panel1: TPanel;
    DriveComboBox1: TDriveComboBox;
    Button1: TButton;
    DirectoryOutline1: TDirectoryOutline;
    Edit1: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Edit2: TEdit;
    Label5: TLabel;
    Button2: TButton;
    Panel2: TPanel;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    Button3: TButton;
    CheckBox5: TCheckBox;
    GroupBox1: TGroupBox;
    Button4: TButton;
    CheckBox6: TCheckBox;
    Edit3: TEdit;
    CheckBox7: TCheckBox;
    CheckBox8: TCheckBox;
    Button5: TButton;
    SaveDialog1: TSaveDialog;
    Panel3: TPanel;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    TrackBar1: TTrackBar;
    Timer1: TTimer;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Panel4: TPanel;
    Label11: TLabel;
    Button6: TButton;
    Button7: TButton;
    CheckBox9: TCheckBox;
    CheckBox10: TCheckBox;
    Button8: TButton;
    Button9: TButton;
    Button10: TButton;
    Button11: TButton;
    Label12: TLabel;
    procedure DriveComboBox1Change(Sender: TObject);
    procedure DirectoryOutline1Click(Sender: TObject);
    procedure DirectoryOutline1Change(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure ListBox1DblClick(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button8Click(Sender: TObject);
    procedure ListBox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ListBox1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Button9Click(Sender: TObject);
  private
    { Private declarations }
    Procedure Format1;{"replace " " with "_" "}
    Procedure Format2;
    Procedure Format3;
    Procedure Format4;
    Procedure Format5;
    Procedure Format6;
    procedure LoadOnCreate; {it loads configuration file mp3.cfg }
    procedure SaveOnExit; {saves curent position}
    procedure SortFiles; {sort mp3s}
    function  FirstZero(i:Integer):String;{add zero to "4"="04"}
    procedure Iscimp3; {search for mp3}
  public
    { Public declarations }
  end;
Type podatki = Record
                 AddSub   : Char;
                 AddMP3   : Char;
                 UpcaseDir: Char;
                 BPS      : String;
                 Rand     : Char;
                 LastPlay : String;
               End;
var
  form1: Tform1;
  Files : Array[0..SFL] Of String;    {only name it can be changed any time}
  Files1: Array[0..SFL] Of String;    {path to mp3}
  FilesRand:Array[0..SFL] Of Boolean; {check if already played mp3}
  Dirs  : Array[0..SFL] Of String;
  Filesc, Filesc1 :Integer;           {counters}
  Dirsc, Dirsc1   :Integer;
  SndLng: Integer;
  SndName: String;
  SndPause:Boolean;
  SndPPos :Integer;
  SndPos  :Integer;
  CDMin   :Word;
  Tipka   :TMouseButton;
implementation

{$R *.DFM}
(**************************************)
  Procedure Tform1.Format1;
  Var i,x:Word;
  Begin
    If filesc>0 then
      For i:=0 To Filesc-1 Do
        For x:=1 to length(Files[i]) do
          If Files[i][x]=' ' Then Files[i][x]:='_';
  End;
  Procedure Tform1.Format2;
  Var i,x:Word;
  Begin
    If filesc>0 then
      For i:=0 To Filesc-1 Do
        For x:=1 to length(Files[i]) do
          If Files[i][x]='\' Then Files[i][x]:=' ';
  End;
  Procedure Tform1.Format3;
  Var i,x:Word;
  Begin
    If filesc>0 then
      For i:=0 To Filesc-1 Do
        For x:=1 to length(Files[i]) do
          If Files[i][x]='_' Then Files[i][x]:=' ';
  End;
  Procedure Tform1.Format4;
  Var i,x,a,c:Word;
  Begin
    If filesc>0 then
      For i:=0 To Filesc-1 Do
      Begin
        x:=Length(Files[i]);a:=0;
        repeat
          If (a=0)and(Files[i][x]='p')Then a:=x;
          Dec(x);
        Until(x=0);
        Delete(Files[i],a-2,4);
      End;
  End;
  Procedure Tform1.Format5;
  Var i,x:Word;
  Begin
    If filesc>0 then
      For i:=0 To Filesc-1 Do
        Delete(Files[i],1,StrToInt(Edit3.Text));
  End;
Procedure Tform1.Format6;
  Var i,x:Word;
  Begin
    If filesc>0 then
      For i:=0 To Filesc-1 Do
        Delete(Files[i],Length(Files[i])-StrToInt(Edit3.Text),StrToInt(Edit3.Text));
  End;

(**************************************)
procedure Tform1.LoadOnCreate;
Var f1:TextFile;
    s:string;
    i:Integer;
    min,sec:word;
    ure1,min1,sec1:string;
    minute,minute1:word;
  function getdir(s:string):String;
  Var i:Word;
  begin
    i:=Length(s);
    repeat
      dec(i);
    until s[i]='\';
    delete(s,i,length(s)-i+1);
    if s[length(s)]<>'\' Then s:=s+'\';
    getdir:=s;
  end;
  Procedure UpcaseDir(Var s:string);
  Var i,a:Word;
  Begin
    i:=Length(s);a:=0;
    Repeat
      if s[i]='\' then a:=1;
      if a=1 then s[i]:=upcase(s[i]);
      Dec(i);
    Until (i=0);
  End;
  Procedure DeleteSub(Var s:string);
  Var i,a:Word;
  Begin
    i:=Length(s);a:=0;
    Repeat
      Dec(i);
    Until (s[i]='\');
    Delete(s,i,Length(s)-i+1);
  End;
Function FindFile(s:String;var size:word):Boolean;
Var SearchRec:TSearchRec;
    Found:Integer;
    fak:word;
Begin
  fak:=14000;
  If Edit2.Text='128' Then fak:=16000;
  Delete(s,length(s),1);
  Found:=FindFirst(s,faAnyFile,SearchRec);
  FindFile:=False;
  If Found=0 Then Begin
    FindFile:=True;
    size:=Round(Searchrec.Size div fak);
  End;
  FindClose(SearchRec);
End;
Function FindCFG(s:String):Boolean;
Var SearchRec:TSearchRec;
    Found:Integer;
Begin
  Found:=FindFirst(s,faAnyFile,SearchRec);
  FindCFG:=False;
  If Found=0 Then FindCFG:=True;
  FindClose(SearchRec);
End;
function FirstZero(i:Integer):String;
  Var s:string;
  Begin
    s:=IntToStr(i);
    If Length(s)=1 Then s:='0'+s;
    FirstZero:=s;
  End;

Begin
  minute1:=0;minute:=0;
  If findcfg(getdir(paramstr(0))+CFG)=true then begin
  filesc:=0;
  AssignFile(f1,getdir(paramstr(0))+CFG);
  Reset(f1);
    while not(eof(f1))do
    Begin
      Readln(f1,Files1[filesc]);
      If FindFile(Files1[filesc],minute)=True Then
      Begin
        minute1:=minute1+minute;
        Files[filesc]:=Files1[filesc];
        Delete(Files[filesc],Length(Files[filesc]),1);
        min:=minute div 60;
        sec:=minute mod 60;
        Files[filesc]:=Files[filesc]+' ['+firstzero(min)+':'+firstzero(sec)+']';
        If Files1[filesc][Length(Files1[filesc])]='A' Then
        Begin
          FilesRand[filesc]:=True;
          Files[filesc]:=Files[filesc]+'  <-';
        End
        Else FilesRand[filesc]:=False;
        Delete(Files1[filesc],Length(Files1[filesc]),1);
        inc(filesc);
      End;
    End;
    {Dec(filesc);}
  CloseFile(f1);
  s:=Files1[filesc];
  If Upcase(s[1])='A' Then CheckBox5.Checked:=True Else CheckBox5.Checked:=False;
  If Upcase(s[2])='A' Then CheckBox10.Checked:=True Else CheckBox10.Checked:=False;
  If Upcase(s[3])='A' Then CheckBox6.Checked:=True Else CheckBox6.Checked:=False;
  If Upcase(s[4])='A' Then CheckBox9.Checked:=True Else CheckBox9.Checked:=False;
  Delete(s,1,4);
  SndPos:=StrToInt(s[1])*100;
  SndPos:=SndPos+StrToInt(s[2])*10;
  SndPos:=SndPos+StrToInt(s[3]);
  Edit2.Text:=IntToStr(SndPos);
  Delete(s,1,3);
  SndPos:=StrToInt(s);
  SndName:=Files1[SndPos];
  ListBox1.Clear;
  If filesc>0 then Begin
    For i:=0 To Filesc-1 Do
    Begin
{     Files[i]:=Files1[i];}
      If CheckBox5.Checked=False Then DeleteSub(Files[i])
      Else
        If CheckBox6.Checked=True Then UpcaseDir(Files[i]);
      ListBox1.Items.Add(Files[i]);
    End;
  End;
  End;
  If filesc>0 then Begin
    ListBox1.ItemIndex:=SndPos;
    SndName:=Files1[ListBox1.ItemIndex];
    SndPos:=ListBox1.ItemIndex;
    ure1:=firstzero(minute1 div 3600);
    min1:=firstzero((minute1 mod 3600)div 60);
    sec1:=firstzero((minute1 mod 3600)mod 60);
    Label1.Caption:=IntToStr(filesc)+' ['+ure1+':'+min1+':'+sec1+']';
    Button4.Enabled:=true;
  End;
End;
procedure Tform1.SaveOnExit;
Var f1:TextFile;
    Podatek: Podatki;
    i:word;
    tom:string;
    ch:char;
  function getdir(s:string):String;
  Var i:Word;
  begin
    i:=Length(s);
    repeat
      dec(i);
    until s[i]='\';
    delete(s,i,length(s)-i+1);
    if s[length(s)]<>'\' Then s:=s+'\';
    getdir:=s;
  end;
  procedure dodaj0(st:byte;var s:string);
  var a,i:word;t:string;
  Begin
    a:=st-length(s);t:='';
    If a>0 Then
    Begin
      for i:=1 to a do t:=t+'0';
      s:=t+s
      ;
    End;
  End;
Begin
  If CheckBox5.Checked=True Then Podatek.AddSub:='A' Else Podatek.AddSub:='B';
  If CheckBox10.Checked=True Then Podatek.AddMP3:='A' Else Podatek.AddMP3:='B';
  If CheckBox6.Checked=True Then Podatek.UpcaseDir:='A' Else Podatek.UpcaseDir:='B';
  If CheckBox9.Checked=True Then Podatek.Rand:='A' Else Podatek.Rand:='B';
  Podatek.BPS:='CCC';Podatek.BPS:=Edit2.Text;
  Dodaj0(3,Podatek.BPS);
  Podatek.LastPlay:='DDDDD';
  If SndPos<0 Then SndPos:=0;
  Podatek.LastPlay:=IntToStr(SndPos);
  Dodaj0(5,Podatek.LastPlay);
  tom:='';
  tom:=Podatek.AddSub+Podatek.AddMP3+Podatek.UpcaseDir+Podatek.Rand;
  tom:=tom+Podatek.BPS+Podatek.LastPlay;

  AssignFile(f1,getdir(paramstr(0))+CFG);
  Rewrite(f1);
  If filesc>0 then Begin
    For i:=0 To Filesc-1 Do
    Begin
      If FilesRand[i]=true Then ch:=#65 else ch:=#66;
      Writeln(f1,Files1[i]+ch);
    End;
  End;
  Writeln(f1,tom);
  CloseFile(f1);
End;
procedure Tform1.SortFiles;
  Var i,a:Word;s:string;
      b:boolean;
  begin
    If filesc>0 then Begin
      For i:=0 To Filesc-1 Do
      Begin
        For a:=0 To Filesc Do
        Begin
          If Files[i]<Files[a]Then
          Begin
            S:=Files[a];Files[a]:=Files[i];Files[i]:=s;
            S:=Files1[a];Files1[a]:=Files1[i];Files1[i]:=s;
            b:=FilesRand[a];FilesRand[a]:=FilesRand[i];FilesRand[i]:=b;
          End;
        End;
      End;
    End;
  end;
function  Tform1.FirstZero(i:Integer):String;
  Var s:string;
  Begin
    s:=IntToStr(i);
    If Length(s)=1 Then s:='0'+s;
    FirstZero:=s;
  End;
procedure Tform1.Iscimp3;
Var Found:integer;
    i:Word;
    path:String;
    SearchRec: TSearchRec;
    ure,min,sec,fak:word;
    ure1,min1,sec1:String;
    allmin:real;
  Procedure DodajD(Var s:String);
  Begin
    If s[length(s)]<>'\'Then s:=s+'\';
  End;
  Function JeMP3(s:string):boolean;
  Var v:String;i,a:Word;
  Begin
    v:='MP3';JeMP3:=True;a:=length(s)-2;
    For i:=1 To 3 Do
    Begin
      If (Upcase(v[i])<>Upcase(s[a]))Then JeMP3:=False;inc(a);
    End;
  End;
  Procedure UpcaseDir(Var s:string);
  Var i,a:Word;
  Begin
    i:=Length(s);a:=0;
    Repeat
      if s[i]='\' then a:=1;
      if a=1 then s[i]:=upcase(s[i]);
      Dec(i);
    Until (i=0);
  End;
Begin
  AllMin:=0;
  ListBox1.Clear;
  if CheckBox10.Checked=False Then Begin
    Filesc:=0;Filesc1:=0;
    For i:=0 To 1000 do filesrand[i]:=false;
    CDMin:=0;
  End;
  Dirsc:=1;Dirsc1:=0;
  Path:=edit1.Text;
  Dirs[Dirsc1]:=path;
  Dec(Dirsc1);
Repeat
  Inc(Dirsc1);
  dodajd(Dirs[Dirsc1]);
  Found := FindFirst(Dirs[Dirsc1]+'*.*', faAnyFile, SearchRec);
  while Found = 0 do
    begin
      If((SearchRec.Attr) And (faDirectory)=faDirectory)Then
      Begin
        If ((SearchRec.Name<>'.') And (SearchRec.Name<>'..')) Then Begin
        Dirs[Dirsc]:=Dirs[Dirsc1]+SearchRec.Name;Inc(Dirsc);
        End;
      End;
      If(((SearchRec.Attr And faVolumeID)<>faVolumeID)
        And ((SearchRec.Attr And faDirectory)<>faDirectory))
      Then Begin
        If JeMP3(SearchRec.Name)=True Then Begin
        fak:=14000;
        If Edit2.Text='128' Then fak:=16000;
        allmin:=allmin+(searchrec.size/fak);
        CDMin:=CDMin+Round(allmin);
        min:=round(searchrec.size/fak)div 60;
        sec:=round(searchrec.size/fak)mod 60;
        If CheckBox5.Checked=True Then Begin
          Files[Filesc]:=Dirs[dirsc1]+SearchRec.Name+' ['+FirstZero(min)+':'+FirstZero(sec)+']';
          Files1[Filesc]:=Dirs[dirsc1]+SearchRec.Name;
          If CheckBox6.Checked=True Then UpcaseDir(Files[Filesc]);
          end
        Else
          Files[Filesc]:=SearchRec.Name+' ['+FirstZero(min)+':'+FirstZero(sec)+']';
          Files1[Filesc]:=Dirs[dirsc1]+SearchRec.Name;
        Inc(Filesc);End;
      End;
      Found := FindNext(SearchRec);
    end;
    FindClose(SearchRec);
Until (dirsc1>=dirsc-1);
  ure1:=FirstZero(Round(CDMin) div 3600);
  min1:=FirstZero((Round(CDMin) mod 3600)div 60);
  sec1:=FirstZero((Round(CDMin) mod 3600)mod 60);
  label1.Caption:=inttostr(filesc)+' ['+ure1+':'+min1+':'+sec1+']';
  label4.Caption:=inttostr(dirsc1);
  If filesc>0 then Begin
  Button3.Enabled:=True;Button4.Enabled:=True;
  For i:=0 To Filesc-1 Do
    ListBox1.Items.Add(Files[i]);
  End;
End;
procedure Tform1.DriveComboBox1Change(Sender: TObject);
begin
  DirectoryOutline1.Drive:=DriveComboBox1.Drive;
end;

procedure Tform1.DirectoryOutline1Click(Sender: TObject);
begin
  Edit1.Text:=DirectoryOutline1.Directory;
end;

procedure Tform1.DirectoryOutline1Change(Sender: TObject);
begin
  Edit1.Text:=DirectoryOutline1.Directory;
end;

procedure Tform1.Button1Click(Sender: TObject);
begin
  Iscimp3;
  SndPos:=0;
  SndName:=Files[SndPos];
  ListBox1.ItemIndex:=SndPos;
  SndName:=Files1[ListBox1.ItemIndex];
  SndPos:=ListBox1.ItemIndex;
end;

procedure Tform1.Button2Click(Sender: TObject);
Var s:string;i:integer;
begin
  SortFiles;
  ListBox1.Clear;
  If filesc>0 then Begin
  For i:=0 To Filesc-1 Do
    ListBox1.Items.Add(Files[i]);
  End;
end;

procedure Tform1.Button3Click(Sender: TObject);
Var i,x:Word;

begin
  If CheckBox1.Checked=True Then Format1;
  If CheckBox2.Checked=True Then Format2;
  If CheckBox3.Checked=True Then Format3;
  If CheckBox4.Checked=True Then Format4;
  If CheckBox7.Checked=True Then Format5;
  If CheckBox8.Checked=True Then Format6;
  ListBox1.Clear;
  If filesc>0 then
  For i:=0 To Filesc-1 Do
    ListBox1.Items.Add(Files[i]);
end;

procedure Tform1.Button5Click(Sender: TObject);
begin
  SaveOnExit;
  Form1.Close;
end;

procedure Tform1.Button4Click(Sender: TObject);
begin
  If SaveDialog1.Execute Then
  ListBox1.Items.SaveToFile(SaveDialog1.FileName);
end;

procedure Tform1.FormCreate(Sender: TObject);
Var x:Word;
    com ,s: string; pcom : pchar;
begin
  CDMin:=0;
  Form1.BorderIcons:=[biSystemMenu,biMinimize];
  SndName:='';
  For x:=0 To SFL Do FilesRand[x]:=False;
  LoadOnCreate;
  If WinAmp_Installed=False Then
  Begin
    s:='c:\Program Files\WinAm\winamp.exe';
    com:=  s+ #0;        // makes string null-terminated
    pcom:= @com[1];
    WinExec(pcom, SW_HIDE{,SW_MINIMIZE]});
  End;
  If WinAmp_Installed Then
  Begin
    GroupBox1.Enabled:=True;
    GroupBox1.Caption:='WinAmp Player  ver. '+WinAmp_Ver.VerStr;
  End Else GroupBox1.Caption:='Can''t play WinAmp is not presented!';
  SndPause:=False;
  Randomize;
end;

procedure Tform1.SpeedButton2Click(Sender: TObject);
Var i:Integer;s:string;
begin
  if filesc>0 then begin
  s:=ListBox1.Items[SndPos];
  If s[length(s)]<>'-' Then ListBox1.Items[SndPos]:=ListBox1.Items[SndPos]+'  <-';
  FilesRand[SndPos]:=True;
  SndPause:=False;
If SndName<>'' Then Begin
  If Label9.Caption<>SndName Then
  Begin
    DeletePlayList;
    AddMp3ToPlayList(SndName);
    Repeat
      StartPlay;
      i:=GetOutPutTime(1);SndLng:=i;
{      Label11.Caption:=Inttostr(i);}
    Until (i<>-1);
    Label9.Caption:=SndName;
    Label12.Caption:='Pos: '+IntToStr(SndPos);
  End;
  StartPlay;
  i:=GetOutPutTime(1);SndLng:=i;
  Trackbar1.Max:=i;
  Label6.Caption:='['+FirstZero(i Div 60)+':'+FirstZero(i mod 60)+']';
  Timer1.Enabled:=True;
  end;
End;
end;

procedure Tform1.SpeedButton1Click(Sender: TObject);
begin
  If PlayBackStatus=1 Then Rewind5;
end;

procedure Tform1.SpeedButton5Click(Sender: TObject);
begin
  If PlayBackStatus=1 Then Forward5;
end;

procedure Tform1.SpeedButton4Click(Sender: TObject);
Var x:integer;
begin
  Timer1.Enabled:=false;
  x:=SndLng*1000;
  JumpToTime(x);
  Label6.Caption:='[00:00]';
  Label7.Caption:='<00:00>';
  Label8.Caption:='[00:00]';
  TrackBar1.Position:=0;
end;

procedure Tform1.Timer1Timer(Sender: TObject);
Var i,x:Integer;t:Boolean;s:string;
begin
  i:=GetOutPutTime(0);
  If PlayBackStatus=1 Then
  Begin
    If (i<>(-1)) Then
    Begin
      i:=i div 1000;
      Trackbar1.Position:=i;
      Label8.Caption:='['+FirstZero(i Div 60)+':'+FirstZero(i mod 60)+']';
      i:=SndLng-i;
      Label7.Caption:='<'+FirstZero(i Div 60)+':'+FirstZero(i mod 60)+'>';
    End;
  End;
  If PlayBackStatus=0 Then
  Begin
    {Label6.Caption:='[00:00]';
    Label7.Caption:='<00:00>';
    Label8.Caption:='[00:00]';
    TrackBar1.Position:=0;
    Timer1.Enabled:=False;}
    If Filesc>0 Then Begin
    If CheckBox9.Checked=False Then
    Begin
      If SndPos=Filesc-1 Then SndPos:=0 Else Inc(SndPos);
    End Else
    Begin
      t:=False;
      For x:=0 To Filesc-1 Do If FilesRand[x]=False Then t:=True;
      If t=false Then
        Begin
          ListBox1.Clear;
          For x:=0 To SFL Do FilesRand[x]:=False;
            If filesc>0 then Begin
              For i:=0 To Filesc-1 Do
              ListBox1.Items.Add(Files[i]);
          End;
        End;

      Repeat
        x:=Random(Filesc);SndPos:=x;
      Until FilesRand[SndPos]=False;
    End;
    FilesRand[SndPos]:=true;
    s:=ListBox1.Items[SndPos];
    ListBox1.ItemIndex:=SndPos;
    If s[length(s)]<>'-' Then ListBox1.Items[SndPos]:=ListBox1.Items[SndPos]+'  <-';
    SndName:=Files1[SndPos];
    Label9.Caption:=SndName;
    Label12.Caption:='Pos: '+IntToStr(SndPos);
    DeletePlayList;
    AddMp3ToPlayList(SndName);
    Repeat
      StartPlay;
      i:=GetOutPutTime(1);SndLng:=i;
    Until (i<>-1);
    Trackbar1.Max:=i;
    Label6.Caption:='['+FirstZero(i Div 60)+':'+FirstZero(i mod 60)+']';
  End;  
  End;
end;

procedure Tform1.TrackBar1Change(Sender: TObject);
Var i,x:Integer;
begin
  x:=TrackBar1.Position*1000;
  JumpToTime(x);
end;

procedure Tform1.ListBox1DblClick(Sender: TObject);
Var i:Integer;s:string;
begin
  s:=ListBox1.Items[SndPos];
  If s[length(s)]<>'-' Then ListBox1.Items[SndPos]:=ListBox1.Items[SndPos]+'  <-';
  FilesRand[SndPos]:=True;
  SndPos:=ListBox1.ItemIndex;
  SndName:=Files1[ListBox1.ItemIndex];
  Label9.Caption:=SndName;
  Label12.Caption:='Pos: '+IntToStr(SndPos);
  DeletePlayList;
  AddMp3ToPlayList(SndName);
  Repeat
    StartPlay;
    i:=GetOutPutTime(1);SndLng:=i;
  Until (i<>-1);
  Trackbar1.Max:=i;
  Label6.Caption:='['+FirstZero(i Div 60)+':'+FirstZero(i mod 60)+']';
  Timer1.Enabled:=True;
end;

procedure Tform1.Button6Click(Sender: TObject);
begin
  VolumeUp;
end;

procedure Tform1.Button7Click(Sender: TObject);
begin
  VolumeDown;
end;

procedure Tform1.ListBox1Click(Sender: TObject);
begin
  If Tipka=mbLeft Then Begin
    SndName:=Files1[ListBox1.ItemIndex];
    SndPos:=ListBox1.ItemIndex;
  End;
end;

procedure Tform1.SpeedButton3Click(Sender: TObject);
Var i,x:Integer;
begin
  If SndPause=False Then
  Begin
    Timer1.Enabled:=false;
    SndPPos:=TrackBar1.Position*1000;
    x:=SndLng*1000;
    JumpToTime(x);
    SndPause:=True;
  End Else
  Begin
    Timer1.Enabled:=True;
    Repeat
      StartPlay;
      i:=GetOutPutTime(1);SndLng:=i;
    Until (i<>-1);
    JumpToTime(SndPPos);
    SndPause:=False;
  End;
end;

procedure Tform1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Terminate;
end;

procedure Tform1.Button8Click(Sender: TObject);
begin
  Label1.Caption:='0';
  Label4.Caption:='0';
  Filesc:=0;
  ListBox1.Clear;
end;

procedure Tform1.ListBox1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Tipka:=Button;
  If Tipka=mbRight Then
  Begin
    If Files[Listbox1.ItemIndex][Length(Files[Listbox1.ItemIndex])]='-' Then
    Delete(Files[Listbox1.ItemIndex],Length(Files[Listbox1.ItemIndex])-3,4);
    ListBox1.Items[Listbox1.ItemIndex]:=Files[Listbox1.ItemIndex];
    FilesRand[Listbox1.ItemIndex]:=False;
  End;
end;

procedure Tform1.ListBox1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Tipka:=mbMiddle;
end;

procedure Tform1.Button9Click(Sender: TObject);
Var i,a:Word;
begin
 If filesc>0 Then
 Begin
  a:=ListBox1.ItemIndex;
  If a<Filesc Then
  Begin
    For I:=a+1 To Filesc-1 Do
    Begin
      Files[i-1]:=Files[i];
      Files1[i-1]:=Files1[i];
      FilesRand[i-1]:=FilesRand[i];
    End;
  End;
  ListBox1.ItemIndex:=a;
  Dec(filesc);
  ListBox1.Clear;
  For i:=0 To Filesc-1 Do
    ListBox1.Items.Add(Files[i]);
 End;
end;

end.
